"""
    CityPay Payment API

     This CityPay API is a HTTP RESTful payment API used for direct server to server transactional processing. It provides a number of payment mechanisms including: Internet, MOTO, Continuous Authority transaction processing, 3-D Secure decision handling using RFA Secure, Authorisation, Refunding, Pre-Authorisation, Cancellation/Voids and Completion processing. The API is also capable of tokinsed payments using Card Holder Accounts.  ## Compliance and Security Your application will need to adhere to PCI-DSS standards to operate safely and to meet requirements set out by  Visa and MasterCard and the PCI Security Standards Council. These include  * Data must be collected using TLS version 1.2 using [strong cryptography](#enabled-tls-ciphers). We will not accept calls to our API at   lower grade encryption levels. We regularly scan our TLS endpoints for vulnerabilities and perform TLS assessments   as part of our compliance program. * The application must not store sensitive card holder data (CHD) such as the card security code (CSC) or   primary access number (PAN) * The application must not display the full card number on receipts, it is recommended to mask the PAN   and show the last 4 digits. The API will return this for you for ease of receipt creation * If you are developing a website, you will be required to perform regular scans on the network where you host the   application to meet your compliance obligations * You will be required to be PCI Compliant and the application must adhere to the security standard. Further information   is available from [https://www.pcisecuritystandards.org/](https://www.pcisecuritystandards.org/) * The API verifies that the request is for a valid account and originates from a trusted source using the remote IP   address. Our application firewalls analyse data that may be an attempt to break a large number of security common   security vulnerabilities.   # noqa: E501

    Contact: support@citypay.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from citypay.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from citypay.exceptions import ApiAttributeError


def lazy_import():
    from citypay.model.airline_segment import AirlineSegment
    globals()['AirlineSegment'] = AirlineSegment


class AirlineAdvice(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('carrier_name',): {
            'max_length': 25,
        },
        ('ticket_issue_city',): {
            'max_length': 18,
        },
        ('ticket_issue_name',): {
            'max_length': 26,
        },
        ('ticket_no',): {
            'max_length': 14,
        },
        ('transaction_type',): {
            'max_length': 3,
            'min_length': 3,
        },
        ('no_air_segments',): {
            'inclusive_maximum': 4,
            'inclusive_minimum': 0,
        },
        ('original_ticket_no',): {
            'max_length': 14,
        },
        ('passenger_name',): {
            'max_length': 25,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'carrier_name': (str,),  # noqa: E501
            'number_in_party': (int,),  # noqa: E501
            'segment1': (AirlineSegment,),  # noqa: E501
            'ticket_issue_city': (str,),  # noqa: E501
            'ticket_issue_date': (date,),  # noqa: E501
            'ticket_issue_name': (str,),  # noqa: E501
            'ticket_no': (str,),  # noqa: E501
            'transaction_type': (str,),  # noqa: E501
            'conjunction_ticket_indicator': (bool,),  # noqa: E501
            'eticket_indicator': (bool,),  # noqa: E501
            'no_air_segments': (int,),  # noqa: E501
            'original_ticket_no': (str,),  # noqa: E501
            'passenger_name': (str,),  # noqa: E501
            'segment2': (AirlineSegment,),  # noqa: E501
            'segment3': (AirlineSegment,),  # noqa: E501
            'segment4': (AirlineSegment,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'carrier_name': 'carrier_name',  # noqa: E501
        'number_in_party': 'number_in_party',  # noqa: E501
        'segment1': 'segment1',  # noqa: E501
        'ticket_issue_city': 'ticket_issue_city',  # noqa: E501
        'ticket_issue_date': 'ticket_issue_date',  # noqa: E501
        'ticket_issue_name': 'ticket_issue_name',  # noqa: E501
        'ticket_no': 'ticket_no',  # noqa: E501
        'transaction_type': 'transaction_type',  # noqa: E501
        'conjunction_ticket_indicator': 'conjunction_ticket_indicator',  # noqa: E501
        'eticket_indicator': 'eticket_indicator',  # noqa: E501
        'no_air_segments': 'no_air_segments',  # noqa: E501
        'original_ticket_no': 'original_ticket_no',  # noqa: E501
        'passenger_name': 'passenger_name',  # noqa: E501
        'segment2': 'segment2',  # noqa: E501
        'segment3': 'segment3',  # noqa: E501
        'segment4': 'segment4',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, carrier_name, number_in_party, segment1, ticket_issue_city, ticket_issue_date, ticket_issue_name, ticket_no, transaction_type, *args, **kwargs):  # noqa: E501
        """AirlineAdvice - a model defined in OpenAPI

        Args:
            carrier_name (str): The name of the airline carrier that generated the tickets for airline travel.
            number_in_party (int): The number of people in the party.
            segment1 (AirlineSegment):
            ticket_issue_city (str): The name of the city town or village where the transaction took place.
            ticket_issue_date (date): The date the ticket was issued in ISO Date format (yyyy-MM-dd).
            ticket_issue_name (str): The name of the agency generating the ticket.
            ticket_no (str): This must be a valid ticket number, i.e. numeric (the first 3 digits must represent the valid IATA plate carrier code). The final check digit should be validated prior to submission. On credit charges, this field should contain the number of the original ticket, and not of a replacement. 
            transaction_type (str): This field contains the Transaction Type code assigned to this transaction. Valid codes include:   - `TKT` = Ticket Purchase   - `REF` = Refund   - `EXC` = Exchange Ticket   - `MSC` = Miscellaneous (non-Ticket Purchase- and non-Exchange Ticket-related transactions only). 

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            conjunction_ticket_indicator (bool): true if a conjunction ticket (with additional coupons) was issued for an itinerary with more than four segments. Defaults to false. . [optional]  # noqa: E501
            eticket_indicator (bool): The Electronic Ticket Indicator, a code that indicates if an electronic ticket was issued.  Defaults to true.. [optional]  # noqa: E501
            no_air_segments (int): A value that indicates the number of air travel segments included on this ticket.  Valid entries include the numerals “0” through “4”. Required only if the transaction type is TKT or EXC. . [optional]  # noqa: E501
            original_ticket_no (str): Required if transaction type is EXC.. [optional]  # noqa: E501
            passenger_name (str): The name of the passenger when the traveller is not the card member that purchased the ticket. Required only if the transaction type is TKT or EXC.. [optional]  # noqa: E501
            segment2 (AirlineSegment): [optional]  # noqa: E501
            segment3 (AirlineSegment): [optional]  # noqa: E501
            segment4 (AirlineSegment): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.carrier_name = carrier_name
        self.number_in_party = number_in_party
        self.segment1 = segment1
        self.ticket_issue_city = ticket_issue_city
        self.ticket_issue_date = ticket_issue_date
        self.ticket_issue_name = ticket_issue_name
        self.ticket_no = ticket_no
        self.transaction_type = transaction_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, carrier_name, number_in_party, segment1, ticket_issue_city, ticket_issue_date, ticket_issue_name, ticket_no, transaction_type, *args, **kwargs):  # noqa: E501
        """AirlineAdvice - a model defined in OpenAPI

        Args:
            carrier_name (str): The name of the airline carrier that generated the tickets for airline travel.
            number_in_party (int): The number of people in the party.
            segment1 (AirlineSegment):
            ticket_issue_city (str): The name of the city town or village where the transaction took place.
            ticket_issue_date (date): The date the ticket was issued in ISO Date format (yyyy-MM-dd).
            ticket_issue_name (str): The name of the agency generating the ticket.
            ticket_no (str): This must be a valid ticket number, i.e. numeric (the first 3 digits must represent the valid IATA plate carrier code). The final check digit should be validated prior to submission. On credit charges, this field should contain the number of the original ticket, and not of a replacement. 
            transaction_type (str): This field contains the Transaction Type code assigned to this transaction. Valid codes include:   - `TKT` = Ticket Purchase   - `REF` = Refund   - `EXC` = Exchange Ticket   - `MSC` = Miscellaneous (non-Ticket Purchase- and non-Exchange Ticket-related transactions only). 

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            conjunction_ticket_indicator (bool): true if a conjunction ticket (with additional coupons) was issued for an itinerary with more than four segments. Defaults to false. . [optional]  # noqa: E501
            eticket_indicator (bool): The Electronic Ticket Indicator, a code that indicates if an electronic ticket was issued.  Defaults to true.. [optional]  # noqa: E501
            no_air_segments (int): A value that indicates the number of air travel segments included on this ticket.  Valid entries include the numerals “0” through “4”. Required only if the transaction type is TKT or EXC. . [optional]  # noqa: E501
            original_ticket_no (str): Required if transaction type is EXC.. [optional]  # noqa: E501
            passenger_name (str): The name of the passenger when the traveller is not the card member that purchased the ticket. Required only if the transaction type is TKT or EXC.. [optional]  # noqa: E501
            segment2 (AirlineSegment): [optional]  # noqa: E501
            segment3 (AirlineSegment): [optional]  # noqa: E501
            segment4 (AirlineSegment): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.carrier_name = carrier_name
        self.number_in_party = number_in_party
        self.segment1 = segment1
        self.ticket_issue_city = ticket_issue_city
        self.ticket_issue_date = ticket_issue_date
        self.ticket_issue_name = ticket_issue_name
        self.ticket_no = ticket_no
        self.transaction_type = transaction_type
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
